package de.jg_cody.Teraplex.ui.Terminal;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;

import de.jg_cody.Teraplex.R;

public class TerminalFragment extends Fragment {

    public static String command;

    EditText terminal_edit_text;
    TextView terminal_textView;
    Terminal terminal;
    ScrollView scrollView;
    public static String user, password, ip;

    private TerminalViewModel terminalViewModel;

    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        terminalViewModel =
                new ViewModelProvider(this).get(TerminalViewModel.class);
        View root = inflater.inflate(R.layout.fragment_terminal, container, false);
        SharedPreferences prefs = requireContext().getSharedPreferences("appsettings", Context.MODE_PRIVATE);
        user = prefs.getString("user", null);
        password = prefs.getString("password", null);
        ip = prefs.getString("ip", null);
        if (user == null || ip == null) {
            Toast.makeText(getContext(), getString(R.string.login_saved), Toast.LENGTH_SHORT).show();

        }
        else {
            Toast.makeText(getContext(), ("test"), Toast.LENGTH_SHORT).show();
            scrollView = (ScrollView) root.findViewById((R.id.scrollView));
            terminal_edit_text = (EditText) root.findViewById(R.id.terminal_edit_text);
            terminal_edit_text.setOnKeyListener(new View.OnKeyListener() {
                @Override
                public boolean onKey(View view, int keyCode, KeyEvent keyEvent) {
                    if ((keyEvent.getAction() == KeyEvent.ACTION_DOWN) && (keyCode == KeyEvent.KEYCODE_ENTER)) {
                        terminal.sendTerminalCommand(terminal_edit_text.getText().toString());


                    } else {
                        terminal_textView = (TextView) root.findViewById(R.id.terminal_textView);
                        new Thread() {
                            public void run() {
                                terminal = new Terminal();
                                boolean isFragmentActive = true;
                                while (isFragmentActive == true) {
                                    Fragment myFragment = (Fragment) getActivity().getSupportFragmentManager().findFragmentById(R.id.fragment_terminal);
                                    if (myFragment == null) {

                                        isFragmentActive = false;
                                    }
                                    else if (myFragment.isVisible())
                                    {
                                        isFragmentActive = false;
                                    }

                                    try {
                                        requireActivity().runOnUiThread(new Runnable() {

                                            @Override
                                            public void run() {
                                                boolean atBottom = scrollView.getChildAt(0).getBottom() <= (scrollView.getHeight() + scrollView.getScrollY());
                                                terminal_textView.setText(terminal.getTerminalOutput());
                                                System.out.println(atBottom);

                                                terminal_textView.invalidate();
                                                scrollView.invalidate();
                                                scrollView.fullScroll(View.FOCUS_DOWN);

                                            }
                                        });
                                        Thread.sleep(250);
                                    } catch (InterruptedException e) {
                                        e.printStackTrace();
                                    }
                                }
                            }
                        }.start();
                    }
                    return false;

                }
            });
        }


        return root;
    }


    @Override
    public void onDestroy() {
        super.onDestroy();
    }
}